#include "ps2.h" 
#include "usart.h"		
//Mini STM32
//PS2  
//ԭ@ALIENTEK
//2010/6/17

//PS2ʱƵ10~20Khz(33K)
///͵ƽĳʱΪ25~50us֮.	  
			 
//PS2_Statusǰ״̬־
//[5:4]:ǰģʽ;[7]:յһ
//[6]:У;[3:0]:յݳ;
u8 PS2_Status=CMDMODE; //ĬΪģʽ 
u8 PS2_DATA_BUF[16];   //ps2ݻ

//λ
u8 BIT_Count=0;
	   
//ж15~10
//ÿ11bit,Ϊ1ֽ
//ÿһ(11λ),豸ٻȴ50msٷһ
//ֻ겿,̲ʱδ
//CHECK OK 2010/5/2
void EXTI15_10_IRQHandler(void)
{	  	 
	static u8 tempdata=0;
	static u8 parity=0;  	   
	if(EXTI->PR&(1<<15))//ж15Ӧж
	{
		EXTI->PR=1<<15;  //LINE15ϵжϱ־λ
		if(BIT_Count==0)
		{
			parity=0;
			tempdata=0;
		}
		BIT_Count++;    
		if(BIT_Count>1&&BIT_Count<10)//
		{	  
			tempdata>>=1;
			if(PS2_SDA)
			{
				tempdata|=0x80;
				parity++;//¼1ĸ
			}   
		}else if(BIT_Count==10)//õУλ
		{
			if(PS2_SDA)parity|=0x80;//УλΪ1
		}	   
		if(BIT_Count==11)//յ1ֽڵ
		{
 			BIT_Count=parity&0x7f;//ȡ1ĸ	  
			if(((BIT_Count%2==0)&&(parity&0x80))||((BIT_Count%2==1)&&(parity&0x80)==0))//żУOK
			{					    
				//PS2_Status|=1<<7;//ǵõ	   
				BIT_Count=PS2_Status&0x0f;		
				PS2_DATA_BUF[BIT_Count]=tempdata;//
				if(BIT_Count<15)PS2_Status++;    //ݳȼ1
				BIT_Count=PS2_Status&0x30;	     //õģʽ	  
				switch(BIT_Count)
				{
					case CMDMODE://ģʽ,ÿյһֽڶ
						PS2_Dis_Data_Report();//ֹݴ
						PS2_Status|=1<<7; //ǵõ
						break;
					case KEYBOARD:
						break;
					case MOUSE:
						if(MOUSE_ID==0)//׼,3ֽ
						{
							if((PS2_Status&0x0f)==3)
							{
								PS2_Status|=1<<7;//ǵõ
								PS2_Dis_Data_Report();//ֹݴ
							}
						}else if(MOUSE_ID==3)//չ,4ֽ
						{
							if((PS2_Status&0x0f)==4)
							{
								PS2_Status|=1<<7;//ǵõ
								PS2_Dis_Data_Report();//ֹݴ
							}
						}	 
						break;
				}		   		 
			}else
			{
				PS2_Status|=1<<6;//У
				PS2_Status&=0xf0;//ݼ
			}
			BIT_Count=0;
		} 	 	  
	}			  
}
//ֹݴ
//ʱ,ֹݴ
//CHECK OK 2010/5/2
void PS2_Dis_Data_Report(void)
{
	PS2_Set_Int(0);   //رж
	PS2_SET_SCL_OUT();//SCLΪ
	PS2_SCL_OUT=0;    //ƴ
}
//ʹݴ
//ͷʱ
//CHECK OK 2010/5/2
void PS2_En_Data_Report(void)
{
	PS2_SET_SCL_IN(); //SCLΪ
	PS2_SET_SDA_IN(); //SDA IN
	PS2_SCL_OUT=1;    //   
	PS2_SDA_OUT=1; 
	PS2_Set_Int(1);   //ж
}

//PS2ж
//en:1;0ر;
//CHECK OK 2010/5/2
void PS2_Set_Int(u8 en)
{
	EXTI->PR=1<<15;  //LINE15ϵжϱ־λ
	if(en)EXTI->IMR|=1<<15;//line15ϵж
    else EXTI->IMR&=~(1<<15);//line15ϵж   
}
//ȴPS2ʱsta״̬ı
//sta:1ȴΪ1;0ȴΪ0;
//ֵ:0ʱ߱sta;1ʱ;
//CHECK OK 2010/5/2
u8 Wait_PS2_Scl(u8 sta)
{
	u16 t=0;
	sta=!sta;
	while(PS2_SCL==sta)
	{
		delay_us(1);
		t++;
		if(t>16000)return 1;//ʱ (豸10msڼ״̬)
	}
	return 0;//
}
//ڷ/֮,ȴ豸Ӧ,úȡӦ
//صõֵ 
//0PS2_Status.6=1˴
//CHECK OK 2010/5/2
u8 PS2_Get_Byte(void)
{
	u16 t=0;
	u8 temp=0;
	while(1)//ȴ55ms
	{
		t++;
		delay_us(10);
		if(PS2_Status&0x80)//õһ
		{
			temp=PS2_DATA_BUF[PS2_Status&0x0f-1];
			PS2_Status&=0x70;//յݱ
			break;	
		}else if(t>5500||PS2_Status&0x40)break;//ʱ/մ	   
	}
	PS2_En_Data_Report();//ʹݴ
	return temp;    
}	    
//һPS2.
//ֵ:0޴,,
u8 PS2_Send_Cmd(u8 cmd)
{
	u8 i;
	u8 high=0;//¼1ĸ		 
	PS2_Set_Int(0);   //ж
	PS2_SET_SCL_OUT();//SCLΪ
	PS2_SET_SDA_OUT();//SDA OUT
	PS2_SCL_OUT=0;//ʱ
	delay_us(120);//100us
	PS2_SDA_OUT=0;//
	delay_us(10);
	PS2_SET_SCL_IN();//ͷʱ,PS2豸õһλ,ʼλ
	PS2_SCL_OUT=1;
	if(Wait_PS2_Scl(0)==0)//ȴʱ
	{									  
		for(i=0;i<8;i++)
		{
			if(cmd&0x01)
			{
			    PS2_SDA_OUT=1;
				high++;
			}else PS2_SDA_OUT=0;   
			cmd>>=1;
			//Щطûм,ΪЩطѭ
			Wait_PS2_Scl(1);//ȴʱ 8λ
			Wait_PS2_Scl(0);//ȴʱ
		}
		if((high%2)==0)PS2_SDA_OUT=1;//Уλ 10
		else PS2_SDA_OUT=0;
		Wait_PS2_Scl(1); //ȴʱ 10λ
		Wait_PS2_Scl(0); //ȴʱ
		PS2_SDA_OUT=1;   //ֹͣλ  11	  
 		Wait_PS2_Scl(1);//ȴʱ 11λ
		PS2_SET_SDA_IN();//SDA in
		Wait_PS2_Scl(0);//ȴʱ
		if(PS2_SDA==0)Wait_PS2_Scl(1);//ȴʱ 12λ 
		else 
		{
			PS2_En_Data_Report();
			return 1;//ʧ
		}		
	}else 
	{
		PS2_En_Data_Report();
		return 2;//ʧ
	}
	PS2_En_Data_Report();
	return 0;    //ͳɹ
}
//PS2ʼ				   
//CHECK OK 2010/5/2
void PS2_Init(void)
{
	RCC->APB2ENR|=1<<2;    //ʹPORTAʱ

	JTAG_Set(JTAG_SWD_DISABLE);	
									  
	GPIOA->CRH&=0X0F0FFFFF;//PA13,15ó	
	GPIOA->CRH|=0X80800000;//PA13,15ó	
	GPIOA->ODR|=5<<13;							  	  	 

    AFIO->EXTICR[3]&=0XFFFF0FFF;//EXTI15ӳ䵽PA15
    AFIO->EXTICR[3]|=0<<12;     //EXTI15ӳ䵽PA15 	    		   

	EXTI->IMR|=1<<15;        //line15ϵж
	EXTI->EMR|=1<<15;        //line15ϵ¼	 
    EXTI->FTSR|=1<<15;       //line15 ¼½ش   				  
	MY_NVIC_Init(1,2,EXTI15_10_IRQChannel,2);//䵽ڶ,ռ2,Ӧ3		 
} 














