#ifndef _MMC_SD_H_
#define _MMC_SD_H_		 	 
#include <stm32f10x_lib.h> 
//Mini STM32
//SD  
//ԭ@ALIENTEK
//2010/6/13	

//SDݽǷͷߺ궨  
#define NO_RELEASE      0
#define RELEASE         1		 
// SDͶ  
#define SD_TYPE_MMC     0
#define SD_TYPE_V1      1
#define SD_TYPE_V2      2
#define SD_TYPE_V2HC    4	   
// SDָ  	   
#define CMD0    0       //λ
#define CMD1    1
#define CMD9    9       //9 CSD
#define CMD10   10      //10CID
#define CMD12   12      //12ֹͣݴ
#define CMD16   16      //16SectorSize Ӧ0x00
#define CMD17   17      //17sector
#define CMD18   18      //18Multi sector
#define ACMD23  23      //23ösectorдǰԤȲNblock
#define CMD24   24      //24дsector
#define CMD25   25      //25дMulti sector
#define ACMD41  41      //41Ӧ0x00
#define CMD55   55      //55Ӧ0x01
#define CMD58   58      //58OCRϢ
#define CMD59   59      //59ʹ/ֹCRCӦ0x00
//дӦ
#define MSD_DATA_OK                0x05
#define MSD_DATA_CRC_ERROR         0x0B
#define MSD_DATA_WRITE_ERROR       0x0D
#define MSD_DATA_OTHER_ERROR       0xFF
//SDӦ
#define MSD_RESPONSE_NO_ERROR      0x00
#define MSD_IN_IDLE_STATE          0x01
#define MSD_ERASE_RESET            0x02
#define MSD_ILLEGAL_COMMAND        0x04
#define MSD_COM_CRC_ERROR          0x08
#define MSD_ERASE_SEQUENCE_ERROR   0x10
#define MSD_ADDRESS_ERROR          0x20
#define MSD_PARAMETER_ERROR        0x40
#define MSD_RESPONSE_FAILURE       0xFF
 							   						 	 
//ⲿӦݾ޸!
//Mini STM32ʹõPA3ΪSDCS.
#define	SD_CS  PAout(3) //SDƬѡ					    	  

extern u8  SD_Type;//SD
// 
u8 SD_WaitReady(void);                          //ȴSD
u8 SD_SendCommand(u8 cmd, u32 arg, u8 crc);     //SDһ
u8 SD_SendCommand_NoDeassert(u8 cmd, u32 arg, u8 crc);
u8 SD_Init(void);                               //SDʼ
u8 SD_Idle_Sta(void);                           //SDģʽ

u8 SD_ReceiveData(u8 *data, u16 len, u8 release);//SD
u8 SD_GetCID(u8 *cid_data);                     //SDCID
u8 SD_GetCSD(u8 *csd_data);                     //SDCSD
u32 SD_GetCapacity(void);                       //ȡSD
//USB  SD
u8 MSD_WriteBuffer(u8* pBuffer, u32 WriteAddr, u32 NumByteToWrite);
u8 MSD_ReadBuffer(u8* pBuffer, u32 ReadAddr, u32 NumByteToRead);

u8 SD_ReadSingleBlock(u32 sector, u8 *buffer);  //һsector
u8 SD_WriteSingleBlock(u32 sector, const u8 *buffer); 		//дһsector
u8 SD_ReadMultiBlock(u32 sector, u8 *buffer, u8 count); 	//sector
u8 SD_WriteMultiBlock(u32 sector, const u8 *data, u8 count);//дsector
u8 SD_Read_Bytes(unsigned long address,unsigned char *buf,unsigned int offset,unsigned int bytes);//ȡһbyte
#endif




